import os, os.path, fnmatch, sys, string

from config import do_debug, do_log

try:
    import syslog
    def opendebug(a):
        return syslog.openlog(a, 0, syslog.LOG_DAEMON)

    def debug(text):
        if do_debug:
            return syslog.syslog(text)
    closedebug = syslog.closelog
except:
    def opendebug(a):
        pass
    def debug(text):
        print text
    def closedebug():
        pass


if do_log:
    class Log:
        def __init__(self, logfile=None):
            if not logfile:
                if sys.platform[:3] == 'win':
                    logfile = "c:/pyftpd.log"
                else:
                    logfile = "/tmp/pyftpd.log"
            self.f = open(logfile, "a")
        def log(self, text):
            self.f.write(text+"\n")
            self.f.flush()
        def __del__(self):
            self.f.close()
else:
    class Log:
        def __init__(self, logfile=None):
            pass
        def log(self, text):
            pass

